#if !defined (_SYSPARAMS_H)
#define _SYSPARAMS_H

/* System constants. */
#if defined (__svr4__)

#define PAGESIZE 8192
typedef unsigned long long VMT_word;

#else /* not __svr4__ */
#if defined (__linux__)

#define PAGESIZE 4096
typedef unsigned long VMT_word;

#else /* not __linux__.  Assume a 4k page. */

#define PAGESIZE 4096
typedef unsigned long VMT_word;

#endif /* __linux__ */
#endif /* __svr4__ */

#define WORDS_PER_PAGE 1024

/* Macros used throughout. */
#define TRUE 1
#define FALSE 0

#define MIN(a,b) ((a) > (b) ? (b) : (a))
#define MAX(a,b) ((a) > (b) ? (a) : (b))

#define PAGE_OFF_MASK ((unsigned long)(PAGESIZE - 1))
#define PAGE_BEG_MASK (~0L ^ PAGE_OFF_MASK)
#define PAGE_OFF(a) (((unsigned long)(a)) & PAGE_OFF_MASK)
#define PAGE_BEG(a) (((unsigned long)(a)) & PAGE_BEG_MASK)
#define PAGE_NXT(a) ((((unsigned long)(a)-1) & PAGE_BEG_MASK) + PAGESIZE)
#define PAGE_NUM(a) (((unsigned long)(a)) / PAGESIZE)
#define WORD_BEG(a) (((unsigned long)(a)) & ~3L)

#endif /* _SYSPARAMS_H */
