/* ---------------------------------------------------------------
   The wrapper for main().

   Author: Scott F. Kaplan <sfkaplan@cs.utexas.edu>
   Last modification: September 1998
   --------------------------------------------------------------- */



/* --------------------------------------------------------------- */
#include <stdio.h>
#include "vmtrace.h"
/* --------------------------------------------------------------- */



/* --------------------------------------------------------------- */
extern int __real_main (int argc, char** argv);

int __wrap_main (int argc, char** argv) {

  int returnValue;

  /* Initialize VMTrace. */
  InitVMTrace ();

  /* Call the real main to run the program. */
  returnValue = __real_main (argc, argv);

  /* Clean up VMTrace as needed. */
  ShutdownVMTrace ();

  return returnValue;

}
/* --------------------------------------------------------------- */
