
/*
************************************************************************
**

  The wrapper for read()

  Author: V. B. Balayoghan (vbb@cs.utexas.edu)
  Date: October 1994
  Modified by: Scott F. Kaplan (sfkaplan@cs.utexas.edu)
  Last modified: June 1998

**
************************************************************************
*/


#include <errno.h>
#include "wrap_read.h"

#define BUFSIZE 256

#ifdef __svr4__

extern int __real__read (int fd, char* buf, int len);
#pragma weak __wrap__libc_read = __wrap__read
int __wrap__read (int fd, char* buf, int len)

#else /* not __svr4__ */
#ifdef __linux__

extern int __real_read (int fd, char* buf, int len);
#pragma weak __wrap___libc_read = __wrap_read
#pragma weak __wrap___read = __wrap_read
int __wrap_read (int fd, char* buf, int len)

#endif /* __linux__ */
#endif /* __svr4__ */

{
  char sbuf[BUFSIZE];
  int rval, n_toread, n_read;
  int i;
  char *s, *t;

  for (i= BUFSIZE; i>=0; i--)
    rval+= sbuf[i];

  n_read= 0;

  t= buf;

  while (len > 0)
    {
      n_toread= BUFSIZE<len ? BUFSIZE : len;

      rval = read_VMT(fd, sbuf, n_toread);

      for (i=rval, s=sbuf; i>0; i--)
	*t++= *s++;

      if (rval == n_toread)
	{
	  n_read+= rval;
	  len-= rval;
	}
      else if (rval >= 0)
	return rval+n_read;
      else
	return rval;
    }

  return n_read;
}



int
read_VMT (int fileDescriptor, char* buffer, int bytesToRead) {

  int returnValue;

#if defined (__svr4__)
  returnValue = __real__read(fileDescriptor, buffer, bytesToRead);
#else /* not __svr4__ */
#if defined (__linux__)
  returnValue = __real_read(fileDescriptor, buffer, bytesToRead);
#endif /* __linux__ */
#endif /* __svr4__ */

  return returnValue;

}
