
/*
************************************************************************
**

  The wrapper for readv()

  Author: V. B. Balayoghan (vbb@cs.utexas.edu) 
  Date:   October 1994
  Modified by: Scott F. Kaplan (sfkaplan@cs.utexas.edu)
  Last modified: June 1998

**
************************************************************************
*/


#include <sys/types.h>
#include <sys/uio.h>
#include "wrap_readv.h"

#define BUFSIZE 1024


static char sbuf[BUFSIZE];


#ifdef __svr4__
#pragma weak __wrap__readv = __wrap_readv
int __wrap_readv (int fd, struct iovec* iov, int iovcnt)
#else /* not __svr4__ */
#ifdef __linux__
#pragma weak __wrap___readv = __wrap_readv
int __wrap_readv (int fd, const struct iovec* iov, size_t iovcnt)
#endif /* __linux__ */
#endif /* __svr4__ */

{
  struct iovec iv;
  int rval, len, n_toread, n_read;
  int i;
  char *s, *t;

  n_read= 0;

  iv.iov_base= (caddr_t)sbuf;

  for (; iovcnt>0; iov++, iovcnt--)
    {
      t= iov->iov_base;
      len= iov->iov_len;

      while (len > 0)
	{
	  iv.iov_len= n_toread= BUFSIZE<len ? BUFSIZE : len;

	  rval= __real_readv(fd, &iv, 1);

	  for (i=rval, s=sbuf; i>0; i--)
	    *t++= *s++;

	  if (rval == n_toread)
	    {
	      n_read+= rval;
	      len-= rval;
	    }
	  else if (rval >= 0)
	    return rval+n_read;
	  else
	    return rval;
	}
    }

  return n_read;
}
